/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/


#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>
#include "moxa\devices.h"

FKEYHNDL(key1)
{
	printf("key1\n");
	return 0;
}

FKEYHNDL(key2)
{
	printf("key2\n");
	return 0;
}

FKEYHNDL(key3)
{
	printf("key3\n");
	return 0;
}

FKEYHNDL(key4)
{
	printf("key4\n");
	return 0;
}

FKEYHNDL(key5)
{
	printf("key5\n");
	return 0;
}

int _tmain(int argc, _TCHAR* argv[])
{
	UINT x,y;

	// open the LCM. Returned the width and the height
	HANDLE	mh = mxlcm_open(&x, &y);

	// display width and height
	printf("w=%d,h=%d\n", x,y);

	// clear the LCM screen
	mxlcm_clear(mh);

	// set the cursor location to (0,1), and then show message
	x=0;
	y=1;
	mxlcm_write( mh, "1234567890\n", 11, &x, &y);

	// set the cursor location to (1,2), and then show message
	x=1;
	y=2;
	mxlcm_write( mh, "1234567890\n", 11, &x, &y);

	// display the current cursor location
	printf("%d,%d\n", x,y);
	// append message to the current location
	mxlcm_write( mh, "ABCDEFGH\n", 11, &x, &y);

	// close LCM
	mxlcm_close(mh);

	// buzzer
	mxbeep( 2600, 70);

	// keykad example
	// By click F1 -> F5,  you can see the corresponding message for it
	int		n = 1;
	BOOL	bQuit = FALSE;
	WCHAR	ch;

	while ( TRUE )
	{
		printf("key phase %d\n", n);
		mxfkey_init();

		mxfkey_register("F1", key1, &n);
		n=22;
		mxfkey_register("F2", key2, &n);
		n=33;
		mxfkey_register("F3", key3, &n);
		n=44;
		mxfkey_register("F4", key4, &n);
		n=55;
		mxfkey_register("F5", key5, &n);

		printf("0:quit\n");
		while ( true )
		{
			ch = getwchar();
			if ( ch==(WCHAR)'0' )
			{
				mxfkey_stop();
				bQuit = TRUE;
				break;
			}
		}
		if ( bQuit )
			break;
	}

	return 0;
}

