/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/


#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>

#include "moxa\devices.h"

int _tmain(int argc, _TCHAR* argv[])
{
	BYTE buffer[100];                     // data receiving buffer
	HANDLE hSerial = NULL;                // serial port handle
	DCB dcb;                              // setting structure of Serial port
	WCHAR szPort[10] = L"COM4:";          // define COM4: to be the port of data received
	
	// Open serial port
	hSerial = CreateFile( szPort, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
	if ( hSerial != INVALID_HANDLE_VALUE )
	{
		// Get Port setting structure
		GetCommState(hSerial, &dcb);

		dcb.BaudRate = 115200;                     // set baud rate to 115200 bps
		dcb.fRtsControl = RTS_CONTROL_HANDSHAKE;   // set Hardware flow control
		dcb.ByteSize = 8;                          // data size = 8
		dcb.StopBits = ONESTOPBIT;                 // stop bit = 1
		dcb.Parity = NOPARITY;                     // no parity

		// Update Port setting structure
		SetCommState(hSerial, &dcb);

		DWORD dwReturned = 0;
		// set Mode to RS232
		BYTE bMode = RS232_MODE;
		DeviceIoControl(hSerial, MOXA_SET_OP_MODE, &bMode, sizeof(BYTE), NULL, 0, &dwReturned, NULL);

		// send pattern
		memset(buffer, 0, sizeof(buffer));
		dwReturned = 0;
		while ( TRUE )
		{
			ReadFile( hSerial, buffer, sizeof(buffer), &dwReturned, NULL);

			// dwReturned is the actually data received byte number
			printf("Received size = %d\n", dwReturned );
			if ( dwReturned > 0 ) {
				printf("data = %s\n", buffer );
				break;
			}
		}

		// Close Serial Port Handle
		CloseHandle(hSerial);
	}

	return 0;
}

