/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/

/*
	Appliance of folder event.

	2008/3/25	Freddy Liao
*/
#include "stdafx.h"
#include <windows.h>

/*
	Wait the event of of directory appearance.

	Parameters:
		szParentFolder: The full path of parent folder name
		szFolderName :  The full path of target folder name
		dwTimeout:      0 ~ INFINITE (milliseconds)
	Return:
		TRUE:           Folder appears.
		FALSE:          Timeout.
*/
BOOL WaitFolder(WCHAR *szParentFolder, WCHAR *szFolderName, DWORD dwTimeout)
{
	WIN32_FIND_DATA wfd;
	DWORD	dwReturn = 0;
	BOOL	bolMounted = FALSE;

	do
	{
		// Notification API
		HANDLE hDir = FindFirstChangeNotification( szParentFolder, FALSE, FILE_NOTIFY_CHANGE_FILE_NAME | FILE_NOTIFY_CHANGE_DIR_NAME | FILE_NOTIFY_CHANGE_LAST_WRITE );

		dwReturn = WaitForSingleObject(hDir, dwTimeout);
		if ( dwReturn == WAIT_OBJECT_0 )
		{
			HANDLE hf = FindFirstFile( szFolderName, &wfd );
			// mounted
			if ( hf != INVALID_HANDLE_VALUE )
			{
				FindClose(hf);
				bolMounted = TRUE;
				break;
			}
		} 
		else if ( dwReturn == WAIT_TIMEOUT )
		{
			break;
		}

		FindCloseChangeNotification(hDir);
	} while ( TRUE );

	return bolMounted;
}