/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/


#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>
#include "moxa\devices.h"

#include "fsioctl.h"

#define IOCTL_HAL_REBOOT                CTL_CODE(FILE_DEVICE_HAL, 15, METHOD_BUFFERED, FILE_ANY_ACCESS)
typedef BOOL (WINAPI* fpKernelIoControl)( DWORD dwIoControlCode, LPVOID lpInBuf, DWORD nInBufSize, LPVOID lpOutBuf, DWORD nOutBufSize, LPDWORD lpBytesReturned );

int _tmain(int argc, _TCHAR* argv[])
{
	DWORD	dwWatchdogPeriod = 10 * 1000;   // time cycle to feed dog ( 10 seconds )

	HMODULE hCoreDLL = LoadLibrary( TEXT("coredll.dll") );
	fpKernelIoControl KernelIoControl = (fpKernelIoControl)GetProcAddress(hCoreDLL, TEXT("KernelIoControl") );

	// If the watchdog service was started, the watchdog would be unstable during the test.
	printf( "REMERBER to stop Wathcdog Service first(From Web Manager)\nPress 'ENTER' to start the watchdog.\n");
	WCHAR chwait = getwchar();

	// starts watchdog timer
	KernelIoControl( IOCTL_HAL_REBOOT, &dwWatchdogPeriod, sizeof(DWORD), NULL, 0, NULL );

	while ( true )
	{
		printf( "Press \"ENTER\" in 10 seconds\n, 'q' to exit");
		WCHAR ch = getwchar();
		if ( ch == (WCHAR)'q' )
		{
			break;
		}
		// refresh watchdog timer
		KernelIoControl( IOCTL_HAL_REBOOT, &dwWatchdogPeriod, sizeof(DWORD), NULL, 0, NULL );
		printf( "  *** fed *** \n");
	}

	// stops watchdog timer
	dwWatchdogPeriod = 0;
	KernelIoControl( IOCTL_HAL_REBOOT, &dwWatchdogPeriod, sizeof(DWORD), NULL, 0, NULL );

	FreeLibrary( hCoreDLL );

	return 0;
}

